function _classPrivateFieldInitSpec(obj, privateMap, value) { _checkPrivateRedeclaration(obj, privateMap); privateMap.set(obj, value); }

function _classPrivateMethodInitSpec(obj, privateSet) { _checkPrivateRedeclaration(obj, privateSet); privateSet.add(obj); }

function _checkPrivateRedeclaration(obj, privateCollection) { if (privateCollection.has(obj)) { throw new TypeError("Cannot initialize the same private elements twice on an object"); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classPrivateFieldGet(receiver, privateMap) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "get"); return _classApplyDescriptorGet(receiver, descriptor); }

function _classExtractFieldDescriptor(receiver, privateMap, action) { if (!privateMap.has(receiver)) { throw new TypeError("attempted to " + action + " private field on non-instance"); } return privateMap.get(receiver); }

function _classApplyDescriptorGet(receiver, descriptor) { if (descriptor.get) { return descriptor.get.call(receiver); } return descriptor.value; }

function _classPrivateMethodGet(receiver, privateSet, fn) { if (!privateSet.has(receiver)) { throw new TypeError("attempted to get private field on non-instance"); } return fn; }

import { scrollWithMarginTop } from './scrollWithMarginTop';
import { onComplete } from './utils/onReady';
/**
 * Scroll to the opened accordion tab
 */

var _addEventListeners = /*#__PURE__*/new WeakSet();

var _handle = /*#__PURE__*/new WeakMap();

export class BootstrapAccordionScrollIntoView {
  constructor({
    extraOffset = 0
  } = {}) {
    _classPrivateMethodInitSpec(this, _addEventListeners);

    _defineProperty(this, "extraOffset", void 0);

    _classPrivateFieldInitSpec(this, _handle, {
      writable: true,
      value: e => {
        let header = null;
        const target = e.target;
        const tabId = target.id;
        const headerId = target.getAttribute('aria-labelledby');

        if (headerId) {
          header = document.querySelector(`#${headerId}`);
        }

        if (!header && tabId) {
          header = document.querySelector(`[data-bs-target="#${tabId}"]`);
        }

        if (header) {
          scrollWithMarginTop(header, this.extraOffset, true);
        }
      }
    });

    this.extraOffset = extraOffset;
    onComplete(() => setTimeout(() => _classPrivateMethodGet(this, _addEventListeners, _addEventListeners2).call(this), 1000));
  }

}

function _addEventListeners2() {
  if ('$' in window) {
    window.$(document).on('shown.bs.collapse', e => {
      _classPrivateFieldGet(this, _handle).call(this, e);
    });
  } else {
    document.addEventListener('shown.bs.collapse', e => {
      _classPrivateFieldGet(this, _handle).call(this, e);
    });
  }
}

export default BootstrapAccordionScrollIntoView;